#ifndef REPET_HPP_
#define REPET_HPP_

#include "symbol.hpp"

template< class Symbol >
class repet
    : public symbol
{
public:
    template< class CharType >
    constexpr repet( const_string< CharType > str , std::size_t begin = 0 )
        : symbol
        (
            Symbol( str , begin ).valid() ?
                repet< Symbol >( str , Symbol( str , begin ).end() ).end() :
                begin
        )
    {
    }
};


#endif
